unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ComCtrls, TDropV, ExtCtrls, TPicFile;

type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FilterComboBox1: TFilterComboBox;
    ImageList1: TImageList;
    Image2: TImage;
    Image1: TImage;
    Image3: TImage;
    Button1: TButton;
    DropView1: TDropView;
    DropView2: TDropView;
    Button2: TButton;
    Image12: TImage;
    Image11: TImage;
    Image13: TImage;
    ImageList2: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    PicFileListBox1: TPicFileListBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    StatusBar1: TStatusBar;
    procedure DirectoryListBox1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FileListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DropView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure PicFileListBox1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure DropView1DropFinished(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DirectoryListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   with Sender as TDirectoryListBox do begin
      if ItemAtPos(Point(X, Y), True) >= 0 then BeginDrag(True);
      end;
end;

procedure TForm1.FileListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ssCtrl in Shift then exit;
   if ssShift in Shift then exit;
   with Sender as TFileListBox do { treat Sender as TFileListBox }
      if ItemAtPos(Point(X, Y), True) >= 0 then begin{ is there an item here? }
         BeginDrag(True);	{ if so, drag it }                         {$IFDEF Debug}DebugForm.Debug('TxRepl32.:FileListBox1InitDrag:'+Sender.ClassName);{$ENDIF}
         end;
   end;

procedure TForm1.FormCreate(Sender: TObject);
   function BoolToStr(ABool: boolean): string;
   begin
      if ABool then Result:='True' else Result:='False';
      end;
begin
   ImageList1.AddIcon(Image1.Picture.Icon);
   ImageList1.AddIcon(Image1.Picture.Icon);
   ImageList1.AddIcon(Image2.Picture.Icon);
   ImageList1.AddIcon(Image3.Picture.Icon);

   ImageList2.AddIcon(Image11.Picture.Icon);
   ImageList2.AddIcon(Image11.Picture.Icon);
   ImageList2.AddIcon(Image12.Picture.Icon);
   ImageList2.AddIcon(Image13.Picture.Icon);

   with DropView1 do
   Label1.Caption:='Can delete: '+BoolToStr(CanDelete)+#13#10+
                   'Empty drop: '+BoolToStr(Empty)+#13#10+
                   'FilterAssn: '+BoolToStr(Assigned(FilterCombo))+#13#10+
                   'StateImage: '+BoolToStr(Assigned(StateImages));

   with DropView2 do
   Label2.Caption:='Can delete: '+BoolToStr(CanDelete)+#13#10+
                   'Empty drop: '+BoolToStr(Empty)+#13#10+
                   'FilterAssn: '+BoolToStr(Assigned(FilterCombo))+#13#10+
                   'StateImage: '+BoolToStr(Assigned(StateImages));
   end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   DropView1.Kill;
   end;

procedure TForm1.DropView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if button=mbRight then MessageDlg(DropView1.GetCompletePath(DropView1.GetNodeAt(x,y)),mtInformation,[mbOk],0);
   end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   DropView2.Kill;
   end;

procedure TForm1.PicFileListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ssCtrl in Shift then exit;
   if ssShift in Shift then exit;
   with Sender as TFileListBox do { treat Sender as TFileListBox }
      if ItemAtPos(Point(X, Y), True) >= 0 then begin{ is there an item here? }
         BeginDrag(True);	{ if so, drag it }                         {$IFDEF Debug}DebugForm.Debug('TxRepl32.:FileListBox1InitDrag:'+Sender.ClassName);{$ENDIF}
         end;
end;

procedure TForm1.DropView1DropFinished(Sender: TObject);
begin
   DropView1.HalfExpand;
   end;

end.
